"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require('@angular/core');
const router_1 = require('@angular/router');
require('rxjs/add/operator/filter');
// default 
const ROUTE_DATA_PARAM = 'navTitle';
class NavTitle {
}
exports.NavTitle = NavTitle;
let NavTitleComponent = class NavTitleComponent {
    constructor(activatedRouteSnapshot, router) {
        this.activatedRouteSnapshot = activatedRouteSnapshot;
        this.router = router;
        this.separator = '–';
        this.dataParam = ROUTE_DATA_PARAM;
        this.titles = [];
    }
    ngOnInit() {
        this.router.events
            .filter(event => event instanceof router_1.NavigationEnd)
            .subscribe(event => {
            this.titles = this.getNavTitles(this.activatedRouteSnapshot.snapshot);
        });
    }
    getLastChildRoute(activatedSnapshot) {
        let children = activatedSnapshot.children;
        if (children.length === 0) {
            return activatedSnapshot;
        }
        return this.getLastChildRoute(children[0]);
    }
    getNavTitles(activatedSnapshot) {
        let pathFromRoute = this.getLastChildRoute(activatedSnapshot).pathFromRoot;
        let titles = [];
        for (let route of pathFromRoute) {
            if (route.data.hasOwnProperty(this.dataParam) && typeof route.data[this.dataParam] === 'string') {
                titles.push({
                    label: route.data[this.dataParam],
                    url: route.pathFromRoot.filter(r => r.url.length > 0).map(r => r.url[0]).join('/')
                });
            }
        }
        return titles;
    }
};
__decorate([
    core_1.Input(), 
    __metadata('design:type', String)
], NavTitleComponent.prototype, "separator", void 0);
__decorate([
    core_1.Input(), 
    __metadata('design:type', String)
], NavTitleComponent.prototype, "dataParam", void 0);
NavTitleComponent = __decorate([
    core_1.Component({
        selector: 'nav-title',
        template: `<span *ngFor="let t of titles; let last = last;">
      <a routerLink="t.url">{{t.label}}</a><span *ngIf="!last"> {{separator}}</span>
    </span>`,
        styles: ['a{text-decoration:none;}']
    }), 
    __metadata('design:paramtypes', [router_1.ActivatedRoute, router_1.Router])
], NavTitleComponent);
exports.NavTitleComponent = NavTitleComponent;
